package com.bytesw.baraja;

import com.bytesw.baraja.cartas.Carta;
import com.bytesw.baraja.cartas.CartaFigura;
import com.bytesw.baraja.cartas.CartaNumero;
import java.util.ArrayList;

public class Baraja {
    private ArrayList<Carta> cartas;

    public Baraja() {
        this.cartas = new ArrayList<>();
        generarCartas();
    }

    public void generarCartas() {
        generarCartasNumeros();
        generarCartasFiguras();
    }

    private void generarCartasNumeros() {
        final int MIN_VALOR = 2;
        final int MAX_VALOR = 10;
        Palo[] palos = Palo.values();

        for (int p = 0; p < palos.length; p++) {
            Palo paloActual = palos[p];
            for (int i = MIN_VALOR; i <= MAX_VALOR; i++) {
                this.cartas.add(new CartaNumero(i, paloActual));
            }
        }

    }

    private void generarCartasFiguras() {
        char[] letras = {'A', 'J', 'Q', 'K'};
        Palo[] palos = Palo.values();

        for (int p = 0; p < palos.length; p++) {
            Palo paloActual = palos[p];
            for (int i = 0; i < letras.length; i++) {
                char letraActual = letras[i];
                this.cartas.add(new CartaFigura(letraActual, paloActual));
            }
        }
    }

    //obtener una carta aleatoria de la baraja y eliminarla del arreglo
    public Carta obtenerCartaAleatoriaDeLaBaraja(){
        Carta cartaEncontrada = null;
        int numero = numeroAleatorioBaraja(numeroDeCartas());
        cartaEncontrada = cartas.get(numero);
        quitarCartaBaraja(cartaEncontrada);
        return cartaEncontrada;
    }

    private int numeroAleatorioBaraja(int numeroDeCartas){
        final int MIN_VALOR = 1;
        int numero = (int)(Math.random() *
                    (((numeroDeCartas - 1) - MIN_VALOR) + 1)) + MIN_VALOR;
        return numero;
    }

    public int numeroDeCartas(){
        return cartas.size();
    }

    private void quitarCartaBaraja(Carta carta){
        this.cartas.remove(carta);
    }



}
