package com.bytesw.juego;

import com.bytesw.baraja.Baraja;
import java.util.Scanner;

public class Juego {
    private int ganaciaXJuego;
    private Scanner scanner = new Scanner(System.in);
    private Crupier crupier;
    private Jugador jugador;

    public Juego(Crupier crupier, Jugador jugador) {
        this.crupier = crupier;
        this.jugador = jugador;
    }

    public Juego(){}

    /**
     * metodo que retorna el ganador del juego blackjack segun la cercania
     * que tenga el valor de la mano de cada jugador con el numero 21
     */
    public String encontrarGanadorBlackJack(){
        String resultado="";
        int valorManoJugador = jugador.obtenerValorDeLaMano();
        int valorManoCrupier = crupier.obtenerValorDeLaMano();
        int cercaniaJugador21 = 21 - valorManoJugador;
        int cercaniaCrupier21 = 21 - valorManoCrupier;

        resultado = verificaBlackJack(cercaniaJugador21, cercaniaCrupier21);
        return  resultado;
    }
    /**
     * metodo que retorna si el jugador saco BlackJack(Q,J,K,10 + As)
     * donde se verifica si fue en la segunda jugada ya que es en esta la unica
     * posibilidad de conseguir blackjack y tambien verificamos que el crupier no
     * haya sacado 21
     */
    private String verificaBlackJack(int cercaniaJugador21, int cercaniaCrupier21) {
        String resultado;
        if (jugador.getJugadas() == 2 && cercaniaCrupier21 != 0) {
            if (cercaniaJugador21 ==0) { //saca 11 As
                resultado="BlackJack --> Paga por 3";
                ganaciaXJuego=jugador.getApuesta()*3;
                jugador.sumarGanancia(ganaciaXJuego);
            } else {
                resultado = encontrarGanador(cercaniaJugador21, cercaniaCrupier21);
            }
        } else {
            resultado = encontrarGanador(cercaniaJugador21, cercaniaCrupier21);
        }
        return resultado;
    }

    /**
     * Metodo que retorna el ganador segun su cercania a 21
     */
    public String encontrarGanador(int cercaniaJugador21, int cercaniaCrupier21){
        String resultado="";
        if(cercaniaJugador21 < 0 && cercaniaCrupier21 < 0) {
            resultado = "Perdieron los dos";
        }else if(cercaniaCrupier21 < 0){
            resultado="Gano el Jugador!";
            ganaciaXJuego=jugador.getApuesta();
            jugador.sumarGanancia(ganaciaXJuego);
        } else if (cercaniaJugador21 < 0) {
            resultado="Gano el Crupier!";
            ganaciaXJuego=jugador.getApuesta()*(-1);
            jugador.sumarGanancia(ganaciaXJuego);
        } else if ((cercaniaJugador21 < cercaniaCrupier21)) {
            resultado="Gano el Jugador!";
            ganaciaXJuego=jugador.getApuesta();
            jugador.sumarGanancia(ganaciaXJuego);
        }else if (cercaniaJugador21 > cercaniaCrupier21) {
            resultado="Gano el Crupier!";
            ganaciaXJuego=jugador.getApuesta()*(-1);
            jugador.sumarGanancia(ganaciaXJuego);
        } else if (cercaniaJugador21 == cercaniaCrupier21) {
            resultado="Empataron nadie gano";
        }
        return resultado;
    }

    public int obtenerGanaciaJugadorXJuego(){
        return ganaciaXJuego;
    }

    public boolean verificarSiJugadorSacaBlackJack(int valorManoJugador){
        boolean verificar=false;
        int cercaniaJugador21 = 21 - valorManoJugador;
        if (jugador.getJugadas() == 2) {
            if (cercaniaJugador21 == 0) {
                verificar= true;
            }
        }
        return verificar;
    }

    public boolean verificarSiPerdioJugador(){
        boolean verificar= false;
        if (jugador.superoElValor21()) {
            verificar = true;
        }
        return verificar;
    }

    public boolean verificarSiElJugadorLlegoA21(){
        int manoJugador = jugador.obtenerValorDeLaMano();
        boolean verificar= false;
        if (manoJugador==21) {
            verificar = true;
        }
        return verificar;
    }

    public void jugar(){
        System.out.println("------Para empezar ingrese su nombre------");
        String eleccion = scanner.nextLine();
        if (eleccion.equals("salir")) {
            System.out.println("Saliendo...");
            System.exit(0);
        } else {
            Jugador jugador = new Jugador(eleccion);
            System.out.println("Bienevenido " + jugador.getNombre());
            System.out.println("Si quieres empezar a jugar escribe: jugar");
            String elecccionJugar = scanner.nextLine();
            if (elecccionJugar.equals("salir")) {
                System.exit(0);
            } else if (elecccionJugar.equals("jugar")) {
                System.out.println("Para Empezar ingresar Saldo Inicial");
                int saldoInicial = Integer.parseInt(scanner.nextLine());
                if (saldoInicial > 0) {
                    jugador.setSaldoTotal(saldoInicial);
                    opciones(jugador);
                } else {
                    System.out.println("SALDO NO SUFICIENTE");
                }
            }
        }
    }

    public void opciones(Jugador jugador){
        System.out.println("***** Opciones Disponibles *****");
        System.out.println("1. saldo");
        System.out.println("2. historico");
        System.out.println("3. niveles");
        System.out.println("4. salir");
        String eleccion2 = scanner.nextLine();
        switch (eleccion2) {
        case "saldo":
            System.out.println("Tu saldo es: " + jugador.getSaldoTotal());
            System.out.println("Regresar a las opciones?");
            String eleccion3 = scanner.nextLine();
            if(eleccion3.equals("si")){
                opciones(jugador);
            }
            break;

        case "historico":
            System.out.println("Mostrando historico de jugadas...");
            jugador.obtenerHistoricos();
            System.out.println("Regresar a las opciones?");
            String eleccion4 = scanner.nextLine();
            if(eleccion4.equals("si")){
                opciones(jugador);
            }
            break;
        case "niveles":
            System.out.println("***** Niveles Disponibles *****");
            System.out.println("***** Para seleccionar escribe: Nivel NUMERO_NIVEL *****");
            System.out.println("***** Para retroceder escribe: atras *****");
            System.out.println("2. BlackJack");
            System.out.println("3. atras");
            String niveles = scanner.nextLine();
            if (niveles.equals("Nivel 2")) {
                System.out.println("*****BLACKJACK*****");
                nivelBlackJack(scanner,jugador);
            } else if (niveles.equals("atras")) {
                opciones(jugador);
            }
            break;

        case "salir":
            System.out.println("***** Saliendo... *****");
            System.exit(0);
            break;

        default:
            System.exit(0);
            break;
        }
    }

    public void nivelBlackJack(Scanner scanner,Jugador jugador){
        Baraja baraja = new Baraja();
        Mano manoCrupier = new Mano();
        Crupier crupier = new Crupier(manoCrupier,baraja);
        Mano manoJugador = new Mano();
        jugador.agregarMano(manoJugador);
        jugador.setJugadas(0); //Empieza el juego el jugador tiene 0 jugadas
        Juego juego = new Juego(crupier,jugador);
        System.out.println("Para empezar ingrese su apuesta");
        while(scanner.hasNext()) {
            int apuesta = scanner.nextInt();
            if (apuesta <= jugador.getSaldoTotal() && apuesta!=0) {
                jugador.setApuesta(apuesta);
                System.out.println("Jugando...");
                crupier.ponerEnLaManoLaCarta(crupier.sacarCartaDeLaBaraja());
                jugadaBlackJack(jugador, manoCrupier, crupier, manoJugador);
                System.out.println("Quieres Seguir?");
                while (scanner.hasNext()) {
                    preguntarSiQuiereSeguirJugando(scanner, jugador, manoCrupier, crupier, manoJugador, juego);
                }
            } else {
                mensajeIngresarApuesta(jugador);
            }
        }
    }

    private void preguntarSiQuiereSeguirJugando(Scanner scanner, Jugador jugador,
                                                Mano manoCrupier, Crupier crupier,
                                                Mano manoJugador, Juego juego) {
        String siguienteEleccion = scanner.nextLine();
        if (siguienteEleccion.equals("si")) {
            System.out.println("Sacando Cartas...");
            jugadaBlackJack(jugador, manoCrupier, crupier, manoJugador);
            if (juego.verificarSiPerdioJugador()
                || juego.verificarSiElJugadorLlegoA21()
                || juego.verificarSiJugadorSacaBlackJack(jugador.obtenerValorDeLaMano())) {
                if (!jugador.superoElValor21()) {
                    juegaCrupier(crupier, manoCrupier, manoJugador);
                    terminoBlackJack(jugador, juego,crupier,manoCrupier,manoJugador);
                }
                terminoBlackJack(jugador, juego,crupier,manoCrupier,manoJugador);
                preguntarSiQuiereVolverAJugar(scanner, jugador);
            } else {
                System.out.println("Quieres Seguir?");
            }
        } else if (siguienteEleccion.equals("no")) {
            juegaCrupier(crupier, manoCrupier, manoJugador);
            terminoBlackJack(jugador, juego,crupier,manoCrupier,manoJugador);
            preguntarSiQuiereVolverAJugar(scanner, jugador);
        }
    }

    private  void mensajeIngresarApuesta(Jugador jugador) {
        if(jugador.getSaldoTotal()==0){
            System.out.println("Ya no tienes saldo disponible");
            System.out.println("Saliendo...");
            System.exit(0);
        }else{
            System.out.println("La apuesta no puede ser mayor a tu saldo total "
                                + "y no debe ser 0");
            System.out.println("Ingresa otro monto...");
        }
    }

    private void terminoBlackJack(Jugador jugador, Juego juego,Crupier crupier, Mano manoCrupier,
                                  Mano manoJugador) {
        mostrarLasCartasDeLosJugadores(manoCrupier, manoJugador);
        mostrarLaSumaDeLasManos(jugador, crupier);
        mostrarGanadorBlackJack(jugador, juego);
        agregarAlHistoricoLaJugada(jugador, juego);
    }

    private static void juegaCrupier(Crupier crupier, Mano manoCrupier, Mano manoJugador) {
        System.out.println("Crupier Jugando...");
        while(!(manoCrupier.sumarCartasEnLaMano() >= manoJugador.sumarCartasEnLaMano())){
            crupier.ponerEnLaManoLaCarta(crupier.sacarCartaDeLaBaraja());
        }
    }

    private void jugadaBlackJack(Jugador jugador, Mano manoCrupier,
                                 Crupier crupier, Mano manoJugador) {
        jugador.ponerEnLaManoLaCarta(crupier.sacarCartaDeLaBaraja());
        mostrarLasCartasDeLosJugadores(manoCrupier, manoJugador);
        mostrarLaSumaDeLasManos(jugador, crupier);
    }

    private void mostrarLasCartasDeLosJugadores(Mano manoCrupier,
                                                Mano manoJugador) {
        System.out.println("Cartas del Crupier");
        manoCrupier.mostrarCartas();
        System.out.println("Cartas del Jugador");
        manoJugador.mostrarCartas();
    }

    private void mostrarLaSumaDeLasManos(Jugador jugador, Crupier crupier) {
        System.out.println("-----------------------");
        System.out.println("*** Suma Cartas Crupier --> " +
                crupier.obtenerValorDeLaMano());
        System.out.println("*** Suma Cartas Jugador -->" +
                jugador.obtenerValorDeLaMano());
        System.out.println("-----------------------");
    }

    private void preguntarSiQuiereVolverAJugar(Scanner scanner, Jugador jugador) {
        System.out.println("***Quieres volver a jugar?***");
        String siguienteEleccion2 = scanner.nextLine();
        if(siguienteEleccion2.equals("si")){
            nivelBlackJack(scanner, jugador);
        } else if (siguienteEleccion2.equals("no")) {
            System.out.println("SALIENDO...");
            opciones(jugador);
        }
    }

    private void agregarAlHistoricoLaJugada(Jugador jugador, Juego juego) {
        HistoricoResultado historicoResultado =
                new HistoricoResultado(jugador.getApuesta(),
                        juego.obtenerGanaciaJugadorXJuego()
                        , "BlackJack");
        jugador.agregarHistorico(historicoResultado);
    }

    private void mostrarGanadorBlackJack(Jugador jugador, Juego juego) {
        System.out.println("Encontrando Ganador....");
        System.out.println("********************");
        System.out.println(juego.encontrarGanadorBlackJack());
        System.out.println("Nuevo saldo " + jugador.getSaldoTotal());
        System.out.println("********************");
    }

}
